---
title: Body.formData()
slug: Web/API/Body/formData
tags:
  - API
  - BODY
  - Experimental
  - Fetch
  - Fetch API
  - FormData
  - Method
  - NeedsExample
  - Reference
---
<div>{{APIRef("Fetch")}}</div>

<p>The <strong><code>formData()</code></strong> method of the {{domxref("Body")}} mixin takes a {{domxref("Response")}} stream and reads it to completion. It returns a promise that resolves with a {{domxref("FormData")}} object.</p>

<div class="note">
<p><strong>Note</strong>: This is mainly relevant to <a href="/en-US/docs/Web/API/ServiceWorker_API">service workers</a>. If a user submits a form and a service worker intercepts the request, you could for example call <code>formData()</code> on it to obtain a key-value map, modify some fields, then send the form onwards to the server (or use it locally).</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>response</em>.formData()
.then(function(<em>formdata</em>) {
  // do something with your formdata
});</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves with a {{domxref("FormData")}} object.</p>

<h2 id="Example">Example</h2>

<p>TBD.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Fetch','#dom-body-formdata','formData()')}}</td>
   <td>{{Spec2('Fetch')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Body.formData")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
</ul>
